// ---------------------------------------------------------------------------
// - Mthsid.hxx                                                              -
// - afnix:mth module - serial id definition                                 -
// ---------------------------------------------------------------------------
// - This program is free software;  you can redistribute it  and/or  modify -
// - it provided that this copyright notice is kept intact.                  -
// -                                                                         -
// - This program  is  distributed in  the hope  that it will be useful, but -
// - without  any  warranty;  without  even   the   implied    warranty   of -
// - merchantability or fitness for a particular purpose.  In no event shall -
// - the copyright holder be liable for any  direct, indirect, incidental or -
// - special damages arising in any way out of the use of this software.     -
// ---------------------------------------------------------------------------
// - copyright (c) 1999-2019 amaury darsch                                   -
// ---------------------------------------------------------------------------

#ifndef  AFNIX_MTHSID_HXX
#define  AFNIX_MTHSID_HXX

#ifndef  AFNIX_CCNF_HPP
#include "ccnf.hpp"
#endif

namespace afnix {
  // the math serial id [0x0010]
  static const t_byte SRL_RVEC_SID = 0x0000; // r-vector id
  static const t_byte SRL_RPNT_SID = 0x0001; // r-point id
  static const t_byte SRL_RBLK_SID = 0x0002; // r-block id
  static const t_byte SRL_RMTX_SID = 0x0003; // r-matrix id
  static const t_byte SRL_RSPL_SID = 0x0004; // r-samples id
  static const t_byte SRL_PRMT_SID = 0x0010; // permute id

  // the math dispatch id
  static const t_word SRL_DEOD_MTH = 0x0010U;
}

#endif
