# ---------------------------------------------------------------------------
# - CSM0050.als                                                             -
# - afnix:csm service test unit                                             -
# ---------------------------------------------------------------------------
# - This program is free software;  you can redistribute it  and/or  modify -
# - it provided that this copyright notice is kept intact.                  -
# -                                                                         -
# - This program  is  distributed in  the hope  that it will be useful, but -
# - without  any  warranty;  without  even   the   implied    warranty   of -
# - merchantability or fitness for a particular purpose.  In no event shall -
# - the copyright holder be liable for any  direct, indirect, incidental or -
# - special damages arising in any way out of the use of this software.     -
# ---------------------------------------------------------------------------
# - copyright (c) 1999-2019 amaury darsch                                   -
# ---------------------------------------------------------------------------

# @info   blob test unit
# @author amaury darsch

# get the service
interp:library "afnix-csm"

# create a nil blob
trans blb (afnix:csm:Blob)

# check predicate and representation
assert true  (afnix:csm:blob-p blb)
assert "Blob" (blb:repr)

# create an blob by name and info
trans  blb (afnix:csm:Blob "ONE" "ONE DIGIT")
assert ""    (blb:get-rid)
assert "ONE" (blb:get-name)
assert "ONE DIGIT" (blb:get-info)

# test the rid
blb:set-rid "RID"
assert true  (blb:rid-p "RID")
assert "RID" (blb:get-rid)
